VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CColor"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
' Special thanks to ijwelch @ the codejock forum for this code.
' It makes it possible to get the nice gradients on a progress bar,
' based on a single colour property.
' https://forum.codejock.com/forum_posts.asp?TID=15126&PID=52828#52828

Public Event ColorChanged()

Private Declare Sub CopyMemory _
                Lib "kernel32" _
                Alias "RtlMoveMemory" (Destination As Any, _
                                       Source As Any, _
                                       ByVal Length As Long)

Private Declare Function OleTranslateColor _
                Lib "OLEPRO32.DLL" (ByVal OLE_COLOR As Long, _
                                    ByVal HPALETTE As Long, _
                                    pccolorref As Long) As Long

Private Const CLR_INVALID = -1

Private p_OLEColor   As OLE_COLOR
Private p_ColorLng   As Long
Private p_Red        As Byte
Private p_Green      As Byte
Private p_Blue       As Byte
Private p_Hue        As Long
Private p_Saturation As Long
Private p_Luminance  As Long
Private p_HTMLColor  As String
Private p_Alpha      As Byte

Public Property Get Alpha() As Byte
    Alpha = p_Alpha
End Property

Public Property Let Alpha(ByVal BytValue As Byte)
   If p_Alpha <> BytValue Then
    p_Alpha = BytValue
    
    RaiseEvent ColorChanged
   End If
End Property

Public Property Get Blue() As Byte
    Blue = p_Blue
End Property

Public Property Let Blue(ByVal BytValue As Byte)
   If p_Blue <> BytValue Then
    p_Blue = BytValue
    ColorLng = RGB(p_Red, p_Green, p_Blue)
    
    RaiseEvent ColorChanged
    End If
End Property

Public Property Get ColorLng() As Long
    ColorLng = p_ColorLng
End Property

Public Property Let ColorLng(ByVal LonValue As Long)
   If p_ColorLng <> LonValue Then
    p_ColorLng = LonValue
    p_OLEColor = p_ColorLng
    pRecalc
    
    RaiseEvent ColorChanged
    End If
End Property

Public Property Get Green() As Byte
    Green = p_Green
End Property

Public Property Let Green(ByVal BytValue As Byte)
   If p_Green <> BytValue Then
    p_Green = BytValue
    ColorLng = RGB(p_Red, p_Green, p_Blue)
    
    RaiseEvent ColorChanged
   End If
End Property

Public Property Get HTMLColor() As String
    HTMLColor = "#" & p_HTMLColor
End Property

Public Property Let HTMLColor(ByVal StrValue As String)
    Dim R As Byte, G As Byte, B As Byte

   If Left$(StrValue, 1) <> "#" Then
      StrValue = "#" & StrValue
   End If
   If Me.HTMLColor <> StrValue Then
   
        StrValue = Mid$(StrValue, 2)

    'does hex value contain alpha component?
    Select Case LenB(StrValue)
        Case 12 '6 chars
            StrValue = "FF" & StrValue
        Case 16 '8 chars
            'ok
        Case Else
            Err.Raise vbObjectError + 1172, "cColor.HTMLColor", "Invalid hex string."
    End Select

    'str value now contains 8 chars
    p_HTMLColor = StrValue
    p_Alpha = Val("&H" & Mid$(StrValue, 1, 2))
    R = Val("&H" & Mid$(StrValue, 3, 2))
    G = Val("&H" & Mid$(StrValue, 5, 2))
    B = Val("&H" & Mid$(StrValue, 7, 2))
    FromRGB R, G, B
    
    RaiseEvent ColorChanged
   End If
End Property

Public Property Get Hue() As Long
    Hue = p_Hue
End Property

Public Property Let Hue(ByVal LonValue As Long)
   If p_Hue <> LonValue Then
    p_Hue = LonValue
    ColorLng = pHSLToLong(p_Hue, p_Saturation, p_Luminance)
    
    RaiseEvent ColorChanged
   End If
End Property

Public Property Get Luminance() As Long
    Luminance = p_Luminance
End Property

Public Property Let Luminance(ByVal LonValue As Long)
   If p_Luminance <> LonValue Then
    p_Luminance = LonValue
    ColorLng = pHSLToLong(p_Hue, p_Saturation, p_Luminance)
    
    RaiseEvent ColorChanged
   End If
End Property

Public Property Get OLEColor() As OLE_COLOR
    OLEColor = p_OLEColor
End Property

Public Property Let OLEColor(ByVal OLEValue As OLE_COLOR)
   If p_OLEColor <> OLEValue Then
    p_OLEColor = OLEValue
    p_ColorLng = pTranslateColor(p_OLEColor)
    pRecalc
    
    RaiseEvent ColorChanged
   End If
End Property

Public Property Get Red() As Byte
    Red = p_Red
End Property

Public Property Let Red(ByVal BytValue As Byte)
   If p_Red <> BytValue Then
    p_Red = BytValue
    ColorLng = RGB(p_Red, p_Green, p_Blue)
    
    RaiseEvent ColorChanged
   End If
End Property

Public Property Get Saturation() As Long
    Saturation = p_Saturation
End Property

Public Property Let Saturation(ByVal LonValue As Long)
   If p_Saturation <> LonValue Then
    p_Saturation = LonValue
    ColorLng = pHSLToLong(p_Hue, p_Saturation, p_Luminance)
    
    RaiseEvent ColorChanged
   End If
End Property

Private Sub Class_Initialize()
    p_Alpha = 255
    p_ColorLng = 0
End Sub

Public Sub AdjustHSL(H As Long, S As Long, L As Long)
    ColorLng = pHSLToLong(p_Hue + H, p_Saturation + S, p_Luminance + L)
    
    RaiseEvent ColorChanged
End Sub

Public Function Clone() As CColor
    Set Clone = New CColor
    Clone.OLEColor = p_OLEColor
End Function

Public Sub FromHSL(H As Long, S As Long, L As Long)
    ColorLng = pHSLToLong(H, S, L)
    
    RaiseEvent ColorChanged
End Sub

Public Sub FromRGB(R As Byte, G As Byte, B As Byte)
    ColorLng = RGB(R, G, B)
    
    RaiseEvent ColorChanged
End Sub

Public Sub Grayscale()
    ColorLng = ((77& * (p_ColorLng And &HFF&) + 152& * (p_ColorLng And &HFF00&) \ _
            &H100& + 28& * ((p_ColorLng And &HFF0000) \ &H10000)) \ 256&) * &H10101
            
            RaiseEvent ColorChanged
End Sub

Public Sub MakeWebSafe()
    Dim bytData(2) As Byte, lonRet As Long

    CopyMemory bytData(0), p_ColorLng, 3
    ColorLng = RGB(Round(bytData(0) / &H33) * &H33, Round(bytData(1) / &H33) * &H33, _
            Round(bytData(2) / &H33) * &H33)
            
            RaiseEvent ColorChanged
End Sub

Private Sub pCalcHSL()
    Dim lRed         As Long, lGreen As Long, lBlue As Long
    Dim lMax         As Long, lMin As Long
    Dim q            As Single
    Dim lDifference  As Long

    Static Lum(255)  As Long
    Static QTab(255) As Single
    Static init      As Long

    lRed = p_Red
    lGreen = p_Green
    lBlue = p_Blue

    If init = 0 Then

        For init = 2 To 255 ' 0 and 1 are both 0
            Lum(init) = init * 100 / 255
        Next

        For init = 1 To 255
            QTab(init) = 60 / init
        Next

    End If

    If lRed > lGreen Then
        lMax = lRed: lMin = lGreen
    Else
        lMax = lGreen: lMin = lRed
    End If

    If lBlue > lMax Then
        lMax = lBlue
    ElseIf lBlue < lMin Then
        lMin = lBlue
    End If

    p_Luminance = Lum(lMax)
    lDifference = lMax - lMin

    If lDifference Then
        p_Saturation = (lDifference) * 100 / lMax
        q = QTab(lDifference)

        Select Case lMax
            Case lRed

                If lBlue > lGreen Then
                    p_Hue = q * (lGreen - lBlue) + 360
                Else
                    p_Hue = q * (lGreen - lBlue)
                End If

            Case lGreen
                p_Hue = q * (lBlue - lRed) + 120
            Case lBlue
                p_Hue = q * (lRed - lGreen) + 240
        End Select

    End If

End Sub

Private Function pHSLToLong(ByVal H As Long, ByVal S As Long, ByVal L As Long) As Long
    ' by Donald (Sterex 1996), donald@xbeat.net, 20011119
    Dim R    As Long, G As Long, B As Long
    Dim lMax As Long, lMid As Long, lMin As Long
    Dim q    As Single

    pValidateHSL H, S, L
    lMax = (L * 255) / 100
    lMin = (100 - S) * lMax / 100
    q = (lMax - lMin) / 60

    Select Case H
        Case 0 To 60
            lMid = (H - 0) * q + lMin
            R = lMax: G = lMid: B = lMin
        Case 60 To 120
            lMid = -(H - 120) * q + lMin
            R = lMid: G = lMax: B = lMin
        Case 120 To 180
            lMid = (H - 120) * q + lMin
            R = lMin: G = lMax: B = lMid
        Case 180 To 240
            lMid = -(H - 240) * q + lMin
            R = lMin: G = lMid: B = lMax
        Case 240 To 300
            lMid = (H - 240) * q + lMin
            R = lMid: G = lMin: B = lMax
        Case 300 To 360
            lMid = -(H - 360) * q + lMin
            R = lMax: G = lMin: B = lMid
    End Select

    pHSLToLong = B * &H10000 + G * &H100& + R
End Function

Private Function pPadHexByte(ByVal p_Byte As Byte) As String
    ' Return a passed byte value as a 2 digit hex string
    pPadHexByte = Right$("0" & Hex$(p_Byte), 2)
End Function

Private Sub pRecalc()
    p_Red = p_ColorLng And &HFF
    p_Green = (p_ColorLng And &HFF00&) \ &H100&
    p_Blue = (p_ColorLng And &HFF0000) \ &H10000
    pCalcHSL
    p_HTMLColor = pPadHexByte(p_Alpha) & pPadHexByte(p_Red) & pPadHexByte(p_Green) & _
            pPadHexByte(p_Blue)
End Sub

Private Function pTranslateColor(ByVal oClr As OLE_COLOR, _
                                 Optional hPal As Long = 0) As Long

    ' Convert Automation color to Windows color
    If OleTranslateColor(oClr, hPal, pTranslateColor) Then
        pTranslateColor = CLR_INVALID
    End If

End Function

Private Sub pValidateHSL(H As Long, S As Long, L As Long)

    ' by Donald, donald@xbeat.net, 20011119
    ' Hue: 0-360, wrapped around (Hue is a circle)
    '   eg. -2 -> 358, 362 -> 2
    If H < 0 Then
        If H < -2147483520 Then   '5965232 * 360
            H = (H + 2147483520) + 360
        Else
            H = (H + 2147483520)
        End If
    End If

    H = H Mod 360

    ' Saturation: 0-100, cut-off
    '   eg. -2 -> 0, 120 -> 100
    If S < 0 Then
        S = 0
    ElseIf S > 100 Then
        S = 100
    End If

    ' Luminance: same as Saturation
    If L < 0 Then
        L = 0
    ElseIf L > 100 Then
        L = 100
    End If

End Sub



