VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CProgressMarker"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private m_Value As Long

Private WithEvents mo_Color As CColor

Private m_Dirty As Boolean

Public m_Visible As Boolean

Public Property Get Visible() As Boolean
   Visible = m_Visible
End Property

Public Property Let Visible(ByVal p_Visible As Boolean)
   m_Visible = p_Visible
End Property

Public Property Get Value() As Long
   Value = m_Value
End Property

Public Property Let Value(ByVal p_Value As Long)
   If m_Value < 0 Or m_Value > 100 Then
      Err.Raise 5 ' must be 0 to 100 %
   End If

   If m_Value <> p_Value Then
      m_Value = p_Value
      
      m_Dirty = True
   End If
End Property

Public Property Get Color() As CColor
   Set Color = mo_Color
End Property

Public Property Get Xaml(ByVal p_BarWidthPx As Long) As String
   Static s_Xaml As String
   
   Dim l_Center As Long ' The center pixel of the marker
   Dim l_Left As Long   ' The leftmost pixel of the marker
   Dim l_Right As Long  ' The rightmost pixel of the marker
   
   If Not m_Visible Then
      ' No XAML required if marker is not visible
      Exit Property
   End If
   
   If LenB(s_Xaml) = 0 Or m_Dirty Then
      l_Center = p_BarWidthPx * m_Value / 100 + 1
      l_Left = l_Center - 5
      l_Right = l_Center + 5
      
   
      s_Xaml = s_Xaml & "<Polygon Points='" & l_Left & " 0, " & l_Left & " 2, " & l_Center & " 7, " & l_Right & " 2, " & l_Right & " 0' Stroke='#90000000' Fill='" & mo_Color.HTMLColor & "' />"
      s_Xaml = s_Xaml & "<Polyline Points='" & l_Right & " 1, " & l_Left + 1 & " 1, " & l_Center & " 6' Stroke='#90FFFFFF' Fill='#00CC00' />"
      s_Xaml = s_Xaml & "<Line X1='" & l_Right & "' Y1='1' X2='" & l_Center & "' Y2='6' Stroke='#40000000'/>"

      m_Dirty = False
   End If
   
   Xaml = s_Xaml
End Property

Private Sub Class_Initialize()
   Set mo_Color = New CColor
   Me.Visible = True
   Me.Color.FromRGB &H20, &HA0, &H30
End Sub

Private Sub mo_Color_ColorChanged()
   m_Dirty = True
End Sub
