VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CUiAttributes"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' Programmed by Jason Peter Brown (jbrown@statslog.com)
' Public Domain, no warranty, use at own risk!

Implements IReportControlUI

Public Enum SampleAttributes
   attrib_Nothing = &H0
   attrib_Bombed = &H1
   attrib_Starred = &H2
   attrib_Drank = &H4
   attrib_Locked = &H8
   
   [_attrib_First] = attrib_Bombed
   [_attrib_Last] = attrib_Locked
End Enum

Private m_Attributes As SampleAttributes

Public Function AreAttributesSet(ByVal p_Attributes As SampleAttributes)
   AreAttributesSet = m_Attributes And p_Attributes
End Function

Public Property Let Attributes(ByVal p_Attributes As SampleAttributes, ByVal p_Checked As Boolean)
   If p_Checked Then
      m_Attributes = m_Attributes Or p_Attributes
   Else
      m_Attributes = m_Attributes And Not p_Attributes
   End If
End Property

Public Property Get Attributes(ByVal p_Attributes As SampleAttributes) As Boolean
   Attributes = CBool(m_Attributes And p_Attributes)
End Property
   
Private Function GetImageXaml(ByVal p_Attribute As SampleAttributes) As String
   Dim l_ImageId As Long
   Dim l_Checked As Boolean
   
   If Not IsAttribute(p_Attribute) Then
      Err.Raise 5
   End If
   
   If AreAttributesSet(p_Attribute) Then
      l_ImageId = 100 + p_Attribute
      l_Checked = True
   Else
      l_ImageId = 200 + p_Attribute
   End If
   
   GetImageXaml = "<Image Cursor='Hand' ToolTip='" & GetTooltipText(p_Attribute, l_Checked) & "' MouseLeftButtonDown='AttributeMouseDown' MouseLeftButtonUp='AttributeMouseUp' Source='" & l_ImageId & "'/>"
End Function

Private Function IsAttribute(ByVal p_Attribute As SampleAttributes) As Boolean
   Dim l_Log2 As Double
   
   l_Log2 = Log(p_Attribute) / Log(2)
   IsAttribute = (l_Log2 = Int(l_Log2))
End Function

Private Function GetTooltipText(ByVal p_Attribute As SampleAttributes, ByVal p_Checked As Boolean) As String
   Select Case p_Attribute
   Case attrib_Bombed
      If p_Checked Then
         GetTooltipText = "Click to prevent automatic deletion"
      Else
         GetTooltipText = "Click to mark for deletion"
      End If
   Case attrib_Starred
      If p_Checked Then
         GetTooltipText = "Click to set normal status"
      Else
         GetTooltipText = "Click to set special status"
      End If
   Case attrib_Drank
      If p_Checked Then
         GetTooltipText = "Click to empty"
      Else
         GetTooltipText = "Click to fill"
      End If
   Case attrib_Locked
      If p_Checked Then
         GetTooltipText = "Click to unlock"
      Else
         GetTooltipText = "Click to lock"
      End If
   End Select
End Function

Private Property Let IReportControlUI_HeightPx(ByVal RHS As Long)

End Property

Private Property Let IReportControlUI_Value(ByVal p_Value As Long)
   m_Attributes = p_Value
End Property

Private Property Get IReportControlUI_Value() As Long
   IReportControlUI_Value = m_Attributes
End Property

Private Property Let IReportControlUI_WidthPx(ByVal RHS As Long)

End Property

Private Property Get IReportControlUI_Xaml() As String
   Dim i As Long
   
   For i = [_attrib_First] To [_attrib_Last]
      If IsAttribute(i) Then
         IReportControlUI_Xaml = IReportControlUI_Xaml & GetImageXaml(i)
      End If
   Next i
   
   IReportControlUI_Xaml = "<StackPanel Orientation='Horizontal'>" & IReportControlUI_Xaml & "</StackPanel>"
End Property
