VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CUiProgress"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' Programmed by Jason Peter Brown (jbrown@statslog.com)
' Public Domain, no warranty, use at own risk!

Implements IReportControlUI

Public Enum ShowPercentageType
   showpercentagetype_None
   showpercentagetype_Tooltip
   showpercentagetype_OnBar
End Enum

Private m_HeightPx                                As Long
Private m_WidthPx                                 As Long
Private m_Value                                   As Long

Private m_ShowPercentageType                      As ShowPercentageType

Private m_TextShadowPx                            As Long
Private m_TextShadowColor                         As OLE_COLOR
Private m_TextForeColor                           As OLE_COLOR

Private m_BaseColor                               As OLE_COLOR
Private ma_GradientColors(14)                     As CColor

Private m_BarBottomHeightPx                       As Long   ' Height of the bottom bar portion
Private m_BarTopMiddleHeightsPx                   As Long   ' Height to use for each of the Top bar portion and middle bar portion

Private m_Dirty As Boolean ' Flag whether xaml string needs to be regenerated

Private mo_Markers As CProgressMarkers

Public Property Get Markers() As CProgressMarkers
   Set Markers = mo_Markers
End Property

Public Property Let TextShadowColor(ByVal p_Color As OLE_COLOR)
   If m_TextShadowColor <> p_Color Then
      m_TextShadowColor = p_Color
      
      m_Dirty = True
   End If
End Property

Public Property Let TextForecolor(ByVal p_Color As OLE_COLOR)
   If m_TextForeColor <> p_Color Then
      m_TextForeColor = p_Color
      
      m_Dirty = True
   End If
End Property

Public Property Let TextShadowPx(ByVal p_Pixels As Long)
   If m_TextShadowPx <> p_Pixels Then
      m_TextShadowPx = p_Pixels
      
      m_Dirty = True
   End If
End Property

Public Property Let ShowPercentage(ByVal p_ShowPercentageType As ShowPercentageType)
   If m_ShowPercentageType <> p_ShowPercentageType Then
      m_ShowPercentageType = p_ShowPercentageType
      
      m_Dirty = True
   End If
End Property

Public Property Get BaseColor() As OLE_COLOR
   BaseColor = m_BaseColor
End Property
Public Property Let BaseColor(ByVal p_Color As OLE_COLOR)
   Dim lo_BaseColor                               As CColor
   Dim l_Saturation As Long
   
   If m_BaseColor <> p_Color Then
      m_BaseColor = p_Color
   
      ' Special thanks to ijwelch from the Codejock forum for this code
      ' to dynamically calculate progress bar gradient stop colors
      ' based on a single base color
      Set lo_BaseColor = New CColor
      lo_BaseColor.OLEColor = m_BaseColor
      If lo_BaseColor.Luminance > 78 Then lo_BaseColor.Luminance = 78
      If lo_BaseColor.Luminance < 21 Then lo_BaseColor.Luminance = 21
   
       'handle greyscale values
       If lo_BaseColor.Saturation = 0 Then     'it's grayscale
           l_Saturation = -100    'this will force saturation calculations below to result in 0
       Else
           If lo_BaseColor.Saturation > 78 Then lo_BaseColor.Saturation = 78
           If lo_BaseColor.Saturation < 45 Then lo_BaseColor.Saturation = 45
           l_Saturation = lo_BaseColor.Saturation
       End If
      
      'init colors
       Set ma_GradientColors(0) = New CColor
       ma_GradientColors(0).FromHSL lo_BaseColor.Hue, l_Saturation - 45, lo_BaseColor.Luminance + 12
       Set ma_GradientColors(1) = New CColor
       ma_GradientColors(1).FromHSL lo_BaseColor.Hue, l_Saturation - 44, lo_BaseColor.Luminance + 11
       Set ma_GradientColors(2) = New CColor
       ma_GradientColors(2).FromHSL lo_BaseColor.Hue, 0, lo_BaseColor.Luminance + 22
       Set ma_GradientColors(3) = New CColor
       ma_GradientColors(3).FromHSL lo_BaseColor.Hue, l_Saturation - 26, lo_BaseColor.Luminance + 1
       Set ma_GradientColors(4) = New CColor
       ma_GradientColors(4).FromHSL lo_BaseColor.Hue, l_Saturation - 23, lo_BaseColor.Luminance + 1
       Set ma_GradientColors(5) = New CColor
       ma_GradientColors(5).FromHSL lo_BaseColor.Hue, l_Saturation - 40, lo_BaseColor.Luminance + 21
       Set ma_GradientColors(6) = New CColor
       ma_GradientColors(6).FromHSL lo_BaseColor.Hue, l_Saturation - 16, lo_BaseColor.Luminance - 3
       Set ma_GradientColors(7) = New CColor
       ma_GradientColors(7).FromHSL lo_BaseColor.Hue, l_Saturation, lo_BaseColor.Luminance + 10
       Set ma_GradientColors(8) = New CColor
       ma_GradientColors(8).FromHSL lo_BaseColor.Hue, l_Saturation - 33, lo_BaseColor.Luminance + 21
       Set ma_GradientColors(9) = New CColor
       ma_GradientColors(9).FromHSL lo_BaseColor.Hue, l_Saturation - 5, lo_BaseColor.Luminance - 8
       Set ma_GradientColors(10) = New CColor
       ma_GradientColors(10).FromHSL lo_BaseColor.Hue, l_Saturation + 12, lo_BaseColor.Luminance + 9
       Set ma_GradientColors(11) = New CColor
       ma_GradientColors(11).FromHSL lo_BaseColor.Hue, l_Saturation - 33, lo_BaseColor.Luminance + 21
       Set ma_GradientColors(12) = New CColor
       ma_GradientColors(12).FromHSL lo_BaseColor.Hue, l_Saturation + 13, lo_BaseColor.Luminance - 21
       Set ma_GradientColors(13) = New CColor
       ma_GradientColors(13).FromHSL lo_BaseColor.Hue, l_Saturation + 23, lo_BaseColor.Luminance
       Set ma_GradientColors(14) = New CColor
       ma_GradientColors(14).FromHSL lo_BaseColor.Hue, l_Saturation - 28, lo_BaseColor.Luminance + 11
       Set lo_BaseColor = Nothing
    
      m_Dirty = True
   End If
End Property

Private Sub Class_Initialize()
   Set mo_Markers = New CProgressMarkers
   
   Me.TextShadowColor = RGB(&H6F, &H68, &H54)
   Me.TextForecolor = vbWhite
   Me.TextShadowPx = 2

   Me.BaseColor = RGB(&H99, &HC7, &H53)
End Sub

Private Property Let IReportControlUI_HeightPx(ByVal p_Pixels As Long)
   Dim l_InternalHeightPx                         As Long

   p_Pixels = p_Pixels - 6   ' 6 pixels to account for markup position issue in RC item
   If m_HeightPx <> p_Pixels Then
      m_HeightPx = p_Pixels
   
      l_InternalHeightPx = p_Pixels - 6   ' 4 px for border, 2px for bar highlights
      m_BarBottomHeightPx = l_InternalHeightPx * 0.55
      m_BarTopMiddleHeightsPx = l_InternalHeightPx * 0.44 / 2
   
      Do While m_BarBottomHeightPx + (m_BarTopMiddleHeightsPx * 2) > l_InternalHeightPx
         m_BarBottomHeightPx = m_BarBottomHeightPx - 1
      Loop
      Do While m_BarBottomHeightPx + (m_BarTopMiddleHeightsPx * 2) < l_InternalHeightPx
         m_BarBottomHeightPx = m_BarBottomHeightPx + 1
      Loop
      
      m_Dirty = True
   End If
End Property

Private Property Let IReportControlUI_WidthPx(ByVal p_Pixels As Long)
   p_Pixels = p_Pixels - 9  ' 4 pixels to account for markup positioning issues in RC item
                            ' 5 pixels to account for markers at 0% and 100% overshooting edge of progress bar
      
   If m_WidthPx <> p_Pixels Then
      m_WidthPx = p_Pixels
      
      m_Dirty = True
   End If
End Property

Private Property Get IReportControlUI_Value() As Long
   IReportControlUI_Value = m_Value
End Property

Private Property Let IReportControlUI_Value(ByVal p_Value As Long)
   If m_Value <> p_Value Then
      m_Value = p_Value
      
      m_Dirty = True
   End If
End Property

Private Property Get IReportControlUI_Xaml() As String
   IReportControlUI_Xaml = xamlOuter(xamlBarBackground(xamlBar))
   m_Dirty = False
End Property

Private Function xamlBarBackground(ByVal p_InternalXaml As String) As String
   Static s_Xaml As String
   
   If LenB(s_Xaml) = 0 Or m_Dirty Then
      s_Xaml = "<Border Height='" & m_HeightPx - 2 & "' Width='" & m_WidthPx - 2 & "' BorderBrush='#6e97cc' BorderThickness='1'>" & _
                       "<Border.Background>" & _
                       "<LinearGradientBrush StartPoint='0, 0' EndPoint='0,1'>" & _
                       "<GradientStop Color='#c6cbd5' Offset='0'/>" & _
                       "<GradientStop Color='#e0e4ed' Offset='.66'/>" & _
                       "</LinearGradientBrush>" & _
                       "</Border.Background>" & _
                       p_InternalXaml & _
                       "</Border>"
   End If
   
   xamlBarBackground = s_Xaml
End Function

Public Property Get ReportControlUiInterface() As IReportControlUI
   Set ReportControlUiInterface = Me
End Property

Private Function xamlOuter(ByVal p_InternalXaml As String) As String
   Static s_Xaml As String
   Dim lo_Marker As CProgressMarker
   
   If LenB(s_Xaml) = 0 Or m_Dirty Then
      s_Xaml = "<Canvas Margin='-1,-1,0,0' Width='" & m_WidthPx & "' Height='" & m_HeightPx & "' " & IIf(m_ShowPercentageType And showpercentagetype_Tooltip, " ToolTip='" & m_Value & "%'", "") & ">" & _
               "<Border BorderBrush='#00000000' BorderThickness='1'>" & _
               p_InternalXaml & _
               "</Border>"

      ' Rounded inner border
      s_Xaml = s_Xaml & "<Line X1='1' Y1='1' X2='1' Y2='2' Stroke='#9bbae3'/>" & _
                  "<Line X1='1' Y1='" & m_HeightPx - 3 & "' X2='1' Y2='" & m_HeightPx - 2 & "' Stroke='#9bbae3'/>" & _
                  "<Line X1='" & m_WidthPx - 2 & "' Y1='1' X2='" & m_WidthPx - 2 & "' Y2='2' Stroke='#9bbae3'/>" & _
                  "<Line X1='" & m_WidthPx - 2 & "' Y1='" & m_HeightPx - 3 & "' X2='" & m_WidthPx - 2 & "' Y2='" & m_HeightPx - 2 & "' Stroke='#9bbae3'/>" & _
                  "<Line X1='1' Y1='2' X2='1' Y2='" & m_HeightPx - 3 & "' Stroke='#6e97cc'/>" & _
                  "<Line X1='" & m_WidthPx - 2 & "' Y1='2' X2='" & m_WidthPx - 2 & "' Y2='" & m_HeightPx - 3 & "' Stroke='#6e97cc'/>"
   
      ' Rounded outer border
      s_Xaml = s_Xaml & _
                  "<Line X1='0' Y1='1' X2='0' Y2='" & m_HeightPx - 2 & "' Stroke='White'/>" & _
                  "<Line X1='" & m_WidthPx - 1 & "' Y1='1' X2='" & m_WidthPx - 1 & "' Y2='" & m_HeightPx - 2 & "' Stroke='White'/>" & _
                  "<Line X1='1' Y1='0' X2='" & m_WidthPx - 2 & "' Y2='0' Stroke='White'/>" & _
                  "<Line X1='1' Y1='" & m_HeightPx - 1 & "' X2='" & m_WidthPx - 2 & "' Y2='" & m_HeightPx - 1 & "' Stroke='White'/>"
   
   
      If m_ShowPercentageType And showpercentagetype_OnBar Then
         If m_TextShadowPx <> 0 Then
            s_Xaml = s_Xaml & "<Border Width='" & m_WidthPx + m_TextShadowPx & "' Height='" & m_HeightPx + m_TextShadowPx & "'><TextBlock HorizontalAlignment='Center' VerticalAlignment='Center' Foreground='" & xamlOleColorToARGB(m_TextShadowColor, 0) & "' FontWeight='Bold'>" & m_Value & "%</TextBlock></Border>"
         End If
         s_Xaml = s_Xaml & "<Border Width='" & m_WidthPx & "' Height='" & m_HeightPx & "'><TextBlock HorizontalAlignment='Center' VerticalAlignment='Center' Foreground='" & xamlOleColorToARGB(m_TextForeColor, 0) & "' FontWeight='Bold'>" & m_Value & "%</TextBlock></Border>"
      End If
   
      For Each lo_Marker In mo_Markers
         s_Xaml = s_Xaml & lo_Marker.Xaml(m_WidthPx - 4)
      Next lo_Marker
   
      s_Xaml = s_Xaml & "</Canvas>"
   End If
   
   xamlOuter = s_Xaml
End Function

Private Function xamlBarChunk(ByVal p_HeightPx As Long, ByVal p_Gradient1 As String, ByVal p_Gradient2 As String, ByVal p_Gradient3 As String) As String
   Static s_Xaml As String
   
   If LenB(s_Xaml) = 0 Or m_Dirty Then
      ' Coloured bar portion
      s_Xaml = "<StackPanel Orientation='Horizontal'>" & _
                     "<Border Height='" & p_HeightPx & "' Width='" & CLng((m_WidthPx - 4) * m_Value / 100) & "' BorderBrush='White' BorderThickness='0,0,1,0'>" & _
                     "<Border.Background>" & _
                     "<LinearGradientBrush StartPoint='0, 0' EndPoint='1,0'>" & _
                     "<GradientStop Color='" & p_Gradient1 & "' Offset='0'/>" & _
                     "<GradientStop Color='" & p_Gradient2 & "' Offset='.66'/>" & _
                     "<GradientStop Color='" & p_Gradient3 & "' Offset='1'/>" & _
                     "</LinearGradientBrush>" & _
                     "</Border.Background>" & _
                     "</Border>"
      ' Shadow portion
      s_Xaml = s_Xaml & "<Border Height='" & p_HeightPx & "' Width='3'>" & _
                     "<Border.Background>" & _
                     "<LinearGradientBrush StartPoint='0, 0' EndPoint='1,0'>" & _
                     "<GradientStop Color='#b7bdcc' Offset='0'/>" & _
                     "<GradientStop Color='#ced3df' Offset='1'/>" & _
                     "</LinearGradientBrush>" & _
                     "</Border.Background>" & _
                     "</Border>" & _
                     "</StackPanel>"
   End If
   
   xamlBarChunk = s_Xaml
End Function

Private Function xamlBar() As String
   Static s_Xaml As String
   
   If LenB(s_Xaml) = 0 Or m_Dirty Then
      s_Xaml = "<StackPanel Orientation='Vertical' HorizontalAlignment='Left'>"
      s_Xaml = s_Xaml & xamlBarChunk(1, ma_GradientColors(0).HTMLColor, ma_GradientColors(1).HTMLColor, ma_GradientColors(2).HTMLColor)
      s_Xaml = s_Xaml & xamlBarChunk(1, ma_GradientColors(3).HTMLColor, ma_GradientColors(4).HTMLColor, ma_GradientColors(5).HTMLColor)
      s_Xaml = s_Xaml & xamlBarChunk(m_BarTopMiddleHeightsPx, ma_GradientColors(6).HTMLColor, ma_GradientColors(7).HTMLColor, ma_GradientColors(8).HTMLColor)
      s_Xaml = s_Xaml & xamlBarChunk(m_BarTopMiddleHeightsPx, ma_GradientColors(9).HTMLColor, ma_GradientColors(10).HTMLColor, ma_GradientColors(11).HTMLColor)
      s_Xaml = s_Xaml & xamlBarChunk(m_BarBottomHeightPx, ma_GradientColors(12).HTMLColor, ma_GradientColors(13).HTMLColor, ma_GradientColors(14).HTMLColor)
      s_Xaml = s_Xaml & "</StackPanel>"
   End If
   
   xamlBar = s_Xaml
End Function
