VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CUiSwitch"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' Programmed by Jason Peter Brown (jbrown@statslog.com)
' Public Domain, no warranty, use at own risk!


Implements IReportControlUI

Public Enum SampleSwitches
   switch_Sunny
   switch_PartlyCloudy
   switch_Cloudy
   switch_Rainy
   switch_Stormy
   switch_Snowy
   
   [_switch_First] = switch_Sunny
   [_switch_Last] = switch_Snowy
End Enum

Private m_Weather As SampleSwitches

Public Property Get Weather() As SampleSwitches
   Weather = m_Weather
End Property
Public Property Let Weather(ByVal p_Weather As SampleSwitches)
   If p_Weather < [_switch_First] Or p_Weather > [_switch_Last] Then
      Err.Raise 5
   End If

   m_Weather = p_Weather
End Property

Public Sub NextWeather()
   m_Weather = m_Weather + 1
   
   ' Cycle if required
   If m_Weather > [_switch_Last] Then
      m_Weather = [_switch_First]
   End If
End Sub

Public Sub PreviousWeather()
   m_Weather = m_Weather - 1
   
   ' Cycle if required
   If m_Weather < [_switch_First] Then
      m_Weather = [_switch_Last]
   End If
End Sub

Private Function GetTooltipText(ByVal p_Switch As SampleSwitches) As String
   Select Case p_Switch
   Case switch_Sunny
      GetTooltipText = "Sunny"
   Case switch_PartlyCloudy
      GetTooltipText = "Partly Cloudy"
   Case switch_Cloudy
      GetTooltipText = "Cloudy"
   Case switch_Rainy
      GetTooltipText = "Rainy"
   Case switch_Stormy
      GetTooltipText = "Thunderstorms"
   Case switch_Snowy
      GetTooltipText = "Snowy"
   End Select
   
   GetTooltipText = GetTooltipText & " (Click to change weather status)"
End Function

Private Property Let IReportControlUI_HeightPx(ByVal RHS As Long)

End Property

Private Property Get IReportControlUI_Value() As Long
   IReportControlUI_Value = m_Weather
End Property

Private Property Let IReportControlUI_Value(ByVal p_Value As Long)
   m_Weather = p_Value
End Property

Private Property Let IReportControlUI_WidthPx(ByVal RHS As Long)

End Property

Private Property Get IReportControlUI_Xaml() As String
   Dim l_ImageId As Long
   
   l_ImageId = 300 + m_Weather
   
   IReportControlUI_Xaml = "<Image ToolTip='" & GetTooltipText(m_Weather) & "' MouseLeftButtonUp='SwitchMouseUp' Cursor='Hand' Source='" & l_ImageId & "'/>"
End Property
