VERSION 5.00
Object = "{7CAC59E5-B703-4CCF-B326-8B956D962F27}#13.2#0"; "Codejock.ReportControl.v13.2.0.ocx"
Object = "{555E8FCC-830E-45CC-AF00-A012D5AE7451}#13.2#0"; "Codejock.CommandBars.v13.2.0.ocx"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   4275
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6300
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   ScaleHeight     =   4275
   ScaleWidth      =   6300
   StartUpPosition =   3  'Windows Default
   Begin XtremeReportControl.ReportControl ReportControl1 
      Height          =   2295
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   3645
      _Version        =   851970
      _ExtentX        =   6429
      _ExtentY        =   4048
      _StockProps     =   64
   End
   Begin XtremeCommandBars.ImageManager ImageManager1 
      Left            =   3900
      Top             =   3870
      _Version        =   851970
      _ExtentX        =   635
      _ExtentY        =   635
      _StockProps     =   0
      Icons           =   "Form1.frx":0000
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Programmed by Jason Peter Brown (jbrown@statslog.com)
' Public Domain, no warranty, use at own risk!

Private Enum ReportColumns
   reportcolumn_Attributes
   reportcolumn_Switch
   reportcolumn_Progress
End Enum

Private WithEvents mo_MarkupEvents As CMarkupEvents
Attribute mo_MarkupEvents.VB_VarHelpID = -1

Private Sub Form_Load()
   Dim lo_Rec As ReportRecord
   Dim lo_Attributes As CUiAttributes
   Dim lo_Switch As CUiSwitch
   Dim lo_Progress As CUiProgress
   
   ReportControlGlobalSettings.Icons.AddIcons Me.ImageManager1.Icons
   With Me.ReportControl1
      .PaintManager.ColumnStyle = xtpColumnOffice2007
      .ShowRowFocus = False
      
      ' Init markup drawing & event handling
      .EnableMarkup = True
      Set mo_MarkupEvents = New CMarkupEvents
      .MarkupContext.SetHandler mo_MarkupEvents  ' So we can process Markup events
      
      ' Init custom drawing/measuring of report rows/items
      .SetCustomDraw xtpCustomMeasureRow + xtpCustomBeforeDrawRow
   
      ' Init columns & column UI classes
      Set lo_Attributes = New CUiAttributes
      Set lo_Switch = New CUiSwitch
      Set lo_Progress = New CUiProgress
      With lo_Progress
         .ShowPercentage = showpercentagetype_OnBar ' Use showpercentagetype_Tooltip for tooltip progress display
      End With
      
      With .Columns.Add(reportcolumn_Attributes, "Attributes", 72, False)
         Set .Tag = lo_Attributes
      End With
      With .Columns.Add(reportcolumn_Switch, "Switch", 54, False)
         Set .Tag = lo_Switch
      End With
      With .Columns.Add(reportcolumn_Progress, "Progress", 100, False)
         Set .Tag = lo_Progress
      End With
      
      ' Init sample records
      Set lo_Rec = .Records.Add
      With lo_Rec
         .AddItem attrib_Nothing
         .AddItem switch_Sunny
         .AddItem 25
      End With
      
      Set lo_Rec = .Records.Add
      With lo_Rec
         .AddItem attrib_Bombed
         .AddItem switch_Stormy
         .AddItem 66
      End With
      
      Set lo_Rec = .Records.Add
      With lo_Rec
         .AddItem attrib_Starred + attrib_Drank
         .AddItem switch_PartlyCloudy
         .AddItem 100
      End With
      
      .Populate
   End With
End Sub

Private Sub Form_Resize()
   With Me.ReportControl1
      .Move .Left, .Top, Me.ScaleWidth - (.Left * 2), Me.ScaleHeight - (.Top * 2)
   End With
End Sub

Private Sub mo_MarkupEvents_AttributeClicked(ByVal p_AttributeId As SampleAttributes, ByVal p_Check As Boolean)
   Dim lo_Attributes As CUiAttributes
   Dim lo_UiInterface As IReportControlUI
   
   ' Clear/set attribute as required
   
   ' Get the UI class for this column
   Set lo_Attributes = Me.ReportControl1.Columns(reportcolumn_Attributes).Tag
   Set lo_UiInterface = lo_Attributes
   
   lo_UiInterface.Value = Me.ReportControl1.FocusedRow.Record.Item(reportcolumn_Attributes).Value
   lo_Attributes.Attributes(p_AttributeId) = p_Check
   Me.ReportControl1.FocusedRow.Record.Item(reportcolumn_Attributes).Value = lo_UiInterface.Value
   
   Me.ReportControl1.Redraw   ' Always call to refresh display after changing value
End Sub

Private Sub mo_MarkupEvents_SwitchClicked(ByVal p_SwitchId As SampleSwitches)
   Dim lo_Switch As CUiSwitch
   
   ' Cycle switch value
   Set lo_Switch = Me.ReportControl1.Columns(reportcolumn_Switch).Tag
   lo_Switch.Weather = Me.ReportControl1.FocusedRow.Record.Item(1).Value
   lo_Switch.NextWeather
   Me.ReportControl1.FocusedRow.Record.Item(1).Value = lo_Switch.Weather
   
   Me.ReportControl1.Redraw   ' Always call to refresh display after changing value
End Sub

Private Sub ReportControl1_BeforeDrawRow(ByVal Row As XtremeReportControl.IReportRow, ByVal Item As XtremeReportControl.IReportRecordItem, ByVal Metrics As XtremeReportControl.IReportRecordItemMetrics)
   Dim lo_UiInterface As IReportControlUI
   Dim lo_Progress As CUiProgress
   Dim L As Long, t As Long, R As Long, B As Long
   
   ' Get UI Xaml based on underlying item value
   Set lo_UiInterface = Me.ReportControl1.Columns(Item.Index).Tag
   lo_UiInterface.Value = Item.Value

   Row.GetItemRect Item, L, t, R, B
   lo_UiInterface.WidthPx = R - L
   lo_UiInterface.HeightPx = B - t

   If Item.Index = reportcolumn_Progress Then
      Set lo_Progress = lo_UiInterface
      lo_Progress.Markers.RemoveAll ' This isn't ideal, but since we are using a single
                                    ' CUiProgress class to manage all of our progress
                                    ' bar rendering on multiple rows, we need to
                                    ' reset the markers on a row by row basis.
                                    ' In the marker scenario, it might be better to use
                                    ' one CUiProgress class per row, but memory might be
                                    ' a concern if you have lots of rows.
                                    ' Definitely requires experimentation.
      
      ' Try a different progress color
      Select Case Row.Index
      Case 0
         lo_Progress.BaseColor = RGB(&H99, &HC7, &H53)
      Case 1
         lo_Progress.BaseColor = RGB(160, 160, 160)
      
         ' Add a couple of progress markers
         With lo_Progress.Markers.Add
            .Color.FromRGB &HD0, &HD0, &H20
            .Value = 100
         End With
      
         With lo_Progress.Markers.Add
            .Color.FromRGB &H20, &HD0, &HD0
            .Value = 0
         End With
      
         With lo_Progress.Markers.Add
            .Color.FromRGB &H20, &HD0, &H20
            .Value = 50
         End With
      Case 2
         lo_Progress.BaseColor = RGB(245, 65, 53)
      End Select
   End If

   Item.Caption = lo_UiInterface.Xaml
End Sub

Private Sub ReportControl1_MeasureRow(ByVal Row As XtremeReportControl.IReportRow, ByVal hDC As stdole.OLE_HANDLE, ByVal Width As Long, Height As Long)
   Height = 24
End Sub

